
var knownuid=0;
var xol_tlast=0;
var xol_stat='';
var xol_xstat='';

function xol_init()
{
	if(!pref.xol_connect) return;
	class_remove(dge('xol_indicator'),'hidden');
#	xol_status('Checking for YesImOnline availability');
	setTimeout(xol_heartbeat,1000);
	setTimeout(xol_access,500);
}
function xol_heartbeat()
{
	try{
		xol_updates();
	}catch(e){
		dbg('xol hearbeat exception')
	}
	setTimeout(xol_heartbeat,1000);
}
function xol_status(status)
{
	xol_stat=status;
	xol_updates();
}
function xol_xstatus(xstatus)
{
	xol_xstat=xstatus;
	xol_updates();
}
function xol_updates()
{
	xol_show_text();
	xol_show_icon();
}
function xol_show_text()
{
	if(xol_tlast<time()-5) xol_xstat='';
	if(xol_xstat.length==0){
		set_xol(xol_stat,'info');
	}else{
		set_xol('('+xol_xstat+') '+xol_stat,'info');
	}
}
function xol_show_icon()
{
	var icon = 'surge_18_disconnected.png';
	if(xol_tlast<time()-60) {
		// icon already set
	}else if (xol_tlast<time()-30){
		icon='surge_18_offline.png';
	}else{
		icon='surge_18_online.png';
	}
	dge('xol_icon').src='||www||img/'+icon;
}
function xol_access()
{
	dbg('sig_refetch - actioning request')
	sndCorsReq('http://127.0.0.1:7070/checkmail','knownuid='+knownuid, function(chan){
		dbg('~inline.tpl - request completed');
		if (chan.status>500){
#			xol_status('$$st_xol_name$$ <span style="color:#a00">$$st_yes_unavailable$$</span>');
			set_xol('$$st_xol_name$$ <span style="color:#a00">$$st_yes_unavailable$$</span>','info');
#			set_xol('$$st_yes_unavailable$$');
			return;
		}
		xol_tlast = time();
		var res = chan.responseText;
		if(res.substring(0,9)=='+TIMEOUT:'){
			xol_xstatus('poll timeout','info');
		}else if(res.substring(0,8)=='+NEWMSG:'){
			var newuid=parseInt(res.substring(8),10);
			if(newuid > knownuid){
				if(knownuid==0){
					xol_status("YesI'mOnline!",'info');
					dge('xol_icon').src='||www||img/surge_18_online.png';
				}else{
					xol_xstatus('New message uid='+newuid);
#					//  not reliable enough!!
#					window.focus();
#					alert("switched to mail")
				}
				check_new_mail();
				knownuid=newuid;
			}
		}else{
			xol_status('$$st_xol_name$$ <span style="color:#a00">$$st_yes_unavailable$$</span>');
#			xol_status('$$st_yes_unavailable$$');
			return;
		}
		setTimeout(xol_access,0);
	},ch[enOL]);
}

function xol_compose(email,e)
{
	dbg('xol_compose - actioning request')
	sndCorsReq('http://127.0.0.1:7070/compose','email='+email, function(chan){
		if (chan.status==200) return;
		xol_xstatus('XOL native compose failed');
		var jmsg=compose_jmsg([email]);
		jmsg.sim=true;
		show_edit(jmsg,U);
	},ch[enFG]);
}


xadd_event(window,'message',receiveMessage);
function receiveMessage(e)
{
	if(!e) e=event;
	var cmd=e.data;
	if(cmd.substring(0,8)=='compose:'){
		xol_compose(cmd.substring(8),e);
	}else{
		x_alert('RX:'+cmd);
	}
#  dge('yio_hdr').innerHTML='Child Rx:'+e.data;
  if (e.origin !== "http://example.org:8080")
	return;
}
